import pygame
from pygame.locals import *
from lib.SpriteManager import SpriteManager

class Test(SpriteManager):

    def __init__(self):

        SpriteManager.__init__(self)
        self.loadSprites()
        self.defaultSurface(self.move_left)
        self.initialPosition(100,300)
        self.velocity = 10

    def loadSprites(self):
        self.move_left = self.getAnimation('resources/test/andar-izquierda', 'left')
        self.move_right = self.getAnimation('resources/test/andar-izquierda', 'right', True)
        self.move_up = self.getAnimation('resources/test/andar-arriba', 'up')
        self.move_down = self.getAnimation('resources/test/andar-abajo', 'down')
        self.agacharse = self.getAnimation('resources/test/agacharse', 'agacharse')
    


    def moveLeft(self):
        self.move(-self.velocity,0)
        self.surface = self.animate(self.move_left)
        

    def moveRight(self):
        self.move(self.velocity,0)
        self.surface = self.animate(self.move_right)
        

    def moveUp(self):
        self.move(0,-self.velocity)
        self.surface = self.animate(self.move_up)

    def moveDown(self):
        self.move(0,self.velocity)
        self.surface = self.animate(self.move_down)

    def colisionado(self):
        self.surface = self.animate(self.agacharse)
        self.hide()


    def controls(self, controls):

        if controls.joyPressed(0,0):
            self.moveLeft()
        if controls.joyPressed(0,3):
            self.moveRight()
        if controls.joyPressed(0,2):
            self.moveUp()
        if controls.joyPressed(0,1):
            self.moveDown()
        if controls.keyPressed(K_a) and not controls.keyPressed(K_w):
            self.moveLeft()
        if controls.keyPressed(K_d) and not controls.keyPressed(K_s):
            self.moveRight()
        if controls.keyPressed(K_w) and not controls.keyPressed(K_d):
            self.moveUp()
        if controls.keyPressed(K_s) and not controls.keyPressed(K_a):
            self.moveDown()

        if controls.keyPressed(K_a) and controls.keyPressed(K_w):
            self.moveLeft()
            self.moveUp()
        if controls.keyPressed(K_d) and controls.keyPressed(K_s):
            self.moveRight()
            self.moveDown()
        if controls.keyPressed(K_w) and controls.keyPressed(K_d):
            self.moveUp()
            self.moveRight()
        if controls.keyPressed(K_s) and controls.keyPressed(K_a):
            self.moveDown()
            self.moveLeft()
