###############################################################################
## Arcadia Project
##
## Copyright (C) 2009-2010 Arcadia Project arcadia.videogame@gmail.com http://www.arcadiaproject.org/
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 3 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
###############################################################################

import pygame
from pygame.locals import *
import os, sys
from lib.SpriteManager import SpriteManager
import lib.PhysicsManager

class Solapa(SpriteManager):

    def __init__(self, core):
        self.core = core
        SpriteManager.__init__(self)
        self.loadSprites()
        self.defaultSurface(self.solapa)
        self.initialPosition(0,-self.solapa.getFrame().get_rect().height)

        self.physic=lib.PhysicsManager.Physic(0,60,60)  #1 pixel por frame, 60 por segundo.
        self.speedVect.vect=[0,40]             #Lanzamiento!
        


    def loadSprites(self):
        self.solapa = self.getAnimation("game"+os.path.sep+"intro"+os.path.sep+"images"+os.path.sep+"solapa", 'solapa')


    def controls(self, action):

        pass

    def ia(self):
        # bajamos la solapa

        if pygame.time.get_ticks() > 1000:
            top = self.core.screen_height - self.solapa.getFrame().get_rect().height
            if self.rect.top <= top:
                
                self.physic.applyGravity(self)
                if self.max_rect().top > 0:
                    self.rect.top = 0

        

            

