import pygame
from lib import FileManager
from Game import Game

#Lo que necesites
from lib.Shadows import *
from lib.CollisionManager import CollisionManager
import lib.PhysicsManager
from lib.SimpleSurface import SimpleSurface

#Elementos
from minigames.race.fondo import Fondo
from minigames.race.elements.Arcadio import Arcadio
from minigames.race.elements.Enemigo import Enemigo
from minigames.race.elements.Enemigo2 import Enemigo2
from minigames.race.elements.Enemigo3 import Enemigo3


class MiniGame(Game):
    
    def __init__(self, core):
        Game.__init__(self,core)
        self.core = core
        self.startGame("race")
        
        self.fondo = Fondo()
        self.arcadio = Arcadio();
        self.enemigo = Enemigo();
        self.enemigo2 = Enemigo2();
        self.enemigo3 = Enemigo3();
        self.arcadio.mode="run"
        self.bindSpriteToControls(self.arcadio)
        
        #self.players = []
        #self.enemigos = []
        
        #for player in range(1,self.core.players):
            
        #    self.players.append(Arcadio())
        #    self.players[player - 1].mode="run"
        #    self.bindSpriteToControls(self.players[player - 1])

        #for enemigo in range(self.core.players, 4):
        #    self.enemigos.append(Enemigo())

        self.end=False

        self.collisions = CollisionManager()


        #FUENTE DE LETRA

        self.core.font.font=pygame.font.SysFont("Arial", 42)
        posx=self.core.screen_width * 0.5
        posy=self.core.screen_height * 0.55
        color=(255,255,255)

        self.replay = self.core.font.renderText("Pulsa ESPACIO para volver a jugar", posx, posy, color, "center", "center")
        nuevainfo = add_shadow(self.replay.getSurface(), (2,2))
        self.replay.setSurface(nuevainfo)

        posx2=self.core.screen_width - self.core.screen_width * 0.5
        posy2=self.core.screen_height * 0.65
        color2=(255,255,255)

        self.exit = self.core.font.renderText("Pulsa ENTER para salir", posx2, posy2, color2, "center", "center")
        nuevainfo2 = add_shadow(self.exit.getSurface(), (2,2))
        self.exit.setSurface(nuevainfo2)

        self.infobox = SimpleSurface("game/gameover/images/infobox/infobox.png")
        self.infobox.setRect(self.core.screen_width * 0.5, self.core.screen_height * 0.5 - 70, "center", "top")
        #self.infoGanar = self.core.font.renderText("Ganaste!", self.core.screen_width * 0.1, self.core.screen_height * 0.9, (0,0,30), "left", "top")
        #self.infoGanar.setSurface(add_shadow(self.infoGanar.getSurface(), (1,1)))

        #self.infoPerder = self.core.font.renderText("Perdiste!", self.core.screen_width * 0.1, self.core.screen_height * 0.9, (255,0,0), "left", "top")
        #self.infoPerder.setSurface(add_shadow(self.infoPerder.getSurface(), (1,1)))


    def paint(self):

        #Capa 1: FONDO
        self.paintItem(self.fondo)

        #Capa 2: Bichos
        #for arcadio in self.players:
        self.paintItem(self.arcadio)
        #for enemigo in self.enemigos:
        self.paintItem(self.enemigo)
        self.paintItem(self.enemigo2)
        self.paintItem(self.enemigo3)

        #Capa 3: HUB
        #self.paintItem(self.info)
        #self.paintItem(self.info2)

        if self.end==True:
            self.unbindSpritesToControls()
            self.paintItem(self.gameOver())
            self.paintItem(self.infobox)
            self.paintItem(self.replay)
            self.paintItem(self.exit)
        self.paintItem(self.startSurface)

    def logic(self):
        
        self.fondo.ia()
        self.gameOver().ia()
        #for enemigo in self.enemigos:
        if self.end == False:
            self.enemigo.ia()
            self.enemigo2.ia()
            self.enemigo3.ia()

        #colisionporlados = self.collisions.edgeCollision(self.arcadio, self.enemigo)
        #if len(colisionporlados) > 0:
        #   self.arcadio.colisionado()
    



        if self.getVictory()=="arcadio" and self.end==False:
            self.end=True
            #self.message=self.infoGanar
            self.arcadio.winner()

        if self.getVictory()=="enemigo" and self.end==False:
            self.end=True
            #self.message=self.infoPerder
            self.enemigo.winner()

        if self.getVictory()=="enemigo2" and self.end==False:
            self.end=True
            #self.message=self.infoPerder
            self.enemigo2.winner()
            
        if self.getVictory()=="enemigo3" and self.end==False:
            self.end=True
            #self.message=self.infoPerder
            self.enemigo3.winner()
            
        if self.core.controlManager.controlSimple.count(("KEYBUTTON", pygame.K_RETURN)) > 0 and self.end == True:                            
                self.core.game = self.core.games[3]
                self.core.controlManager.controlSimple.pop(self.core.controlManager.controlSimple.index(("KEYBUTTON", pygame.K_RETURN)))


        if self.core.controlManager.controlEvents.count(("KEYBUTTON", pygame.K_SPACE)) > 0 and self.end == True:
            self.end=False
            self.bindSpriteToControls(self.arcadio)

            self.arcadio.rect.left=100
            self.enemigo.rect.left=100
            self.enemigo2.rect.left=100
            self.enemigo3.rect.left=100
            self.message=None
            self.enemigo.movement=1
            self.enemigo2.movement=1
            self.enemigo3.movement=1

        

    #METODOS DE APOYO
    def getVictory(self):
        if (self.arcadio.rect.left + self.arcadio.rect.width >= self.core.screen_width * 0.96):
            return "arcadio"

        if (self.enemigo.rect.left + self.enemigo.rect.width >= self.core.screen_width * 0.96):
            return "enemigo"
            
        if (self.enemigo2.rect.left + self.enemigo2.rect.width >= self.core.screen_width * 0.96):
            return "enemigo2"
            
        if (self.enemigo3.rect.left + self.enemigo3.rect.width >= self.core.screen_width * 0.96):
            return "enemigo3"






